//konverze stareho formatu (TAGy v DB + soubor.txt) do databazove tabulky

procedure ParseOldInfo(radek:string; var sNick,sCacheId,sVer,sTyp,sDat,sOdkaz,sIdText,sNickText,sImgText,sDatText,sUrl:string);
begin
  //ShowMessage('KKKKK radek='+radek);
  sCacheId:=RegexSubstitute('(.*<ID=")(.*?)("\s*/\s*>.*)$',radek,'$2');  //text misto ID kese
  sVer:=RegexSubstitute('(.*<VER=")(.*?)("\s*/\s*>.*)$',radek,'$2');
  sTyp:=RegexSubstitute('(.*<TYP=")(.*?)("\s*/\s*>.*)$',radek,'$2');
  sDat:=RegexSubstitute('(.*<DAT=")(.*?)("\s*/\s*>.*)$',radek,'$2');
  sOdkaz:=RegexSubstitute('(.*<GUID=")(.*?)("\s*/\s*>.*)$',radek,'$2'); //GUID ownera CWG
  sIdText:=RegexSubstitute('(.*<TXT_ID=")(.*?)("\s*/\s*>.*)$',radek,'$2'); //bublina ke kesi
  sNickText:=RegexSubstitute('(.*<TXT_NICK=")(.*?)("\s*/\s*>.*)$',radek,'$2'); //bublina k CWG (nicku)
  sImgText:=RegexSubstitute('(.*<TXT_CWG=")(.*?)("\s*/\s*>.*)$',radek,'$2'); //bublina k obrazku
  sDatText:=RegexSubstitute('(.*<TXT_DAT=")(.*?)("\s*/\s*>.*)$',radek,'$2'); //bublina k datu
  sUrl:=RegexSubstitute('(.*<URL=")(.*?)("\s*/\s*>.*)$',radek,'$2'); //obrazek mimo katalog

  sNick:=fetch(radek,'(<');
  radek:=sNick;
  sNick:=Fetch(radek,'|'); //potlacime informaci o katalogu, z ktereho je CWG
  {
  if(sNick='*Mio*') then ShowMessage('KKKKK Parsovani: radek='+radek+CRLF
    +'sCacheId='+sCacheId+CRLF
    +'sVer='+sVer+CRLF
    +'sTyp='+sTyp+CRLF
    +'sDat='+sDat+CRLF
    +'sOdkaz='+sOdkaz+CRLF
    +'sIdText='+sIdText+CRLF
    +'sNickText='+sNickText+CRLF
    +'sImgText='+sImgText+CRLF
    +'sDatText='+sDatText+CRLF
    +'sUrl='+sUrl+CRLF
  );
  }
  //upravit ziskane hodnoty
  if(sVer='') then sVer:='1';
  if(sTyp='') then sTyp:='CWG';
  //GUID doplnime na plne URL (rozlisujeme GUID od WP)
end;

procedure AddFoundCwg(sNick,sCacheId,sVer,sCat,sTyp,sDat,sOdkaz,sUrl,sIdText,sNickText,sImgText,sDatText,sTabGroup:string;iIsCacheFound:integer);
var s:string;
    i,iId:Integer;
    tab:TSQLiteTable;
begin
  //upravit vstupni data
  if(sDat<>'') then sDat:=DDMMRRRRToRRRRMMDD(sDat); //konverze data na databazove
  //pokud uz je CWG v databazi, upravim mu pocet, jinak pridame nove
  s:=AnsiToUpAscii(sNick)+VerToSuffix(StrToInt(sVer));
  CwgDB.ParamsClear();
  CwgDB.AddParamText(':nameUp',s);
  i:=CwgDB.GetTableValue('SELECT Cnt FROM '+TABLE_FOUND+' WHERE NameUpAscii=:nameUp');
  if(i>0) then begin
    i:=i+1;
    CwgDB.ParamsClear();
    CwgDB.AddParamInt(':cnt',i);
    s:=AnsiToUpAscii(sNick)+VerToSuffix(StrToInt(sVer));
    CwgDB.AddParamText(':nameUp',s);
    s:='UPDATE '+TABLE_FOUND+' SET CNT=:cnt WHERE NameUpAscii=:nameUp';
    CwgDB.ExecSQL(s);
  end else begin
    //najdeme, zda dany nick a verze je v katalogu a pokud ano, prevezmeme
    //jeho ID a kategorii
    s:=AnsiToUpAscii(sNick)+VerToSuffix(StrToInt(sVer));
    CwgDB.ParamsClear();
    CwgDB.AddParamText(':nameUp',s);
    tab:=CwgDB.GetTable('SELECT id,category from '+TABLE_CATALOG+' WHERE NameUpAscii=:nameUp',false);
    try
      if(not tab.eof) then begin
        iId:=tab.FieldAsInteger(0);
        sCat:=tab.FieldAsString(1);
      end
      else begin
        iId:=UpdateLastId(true); //cislo pro polozku, ktera neni v katalogu CWG
        sCat:=sTyp;
      end;
     //zapsat informace do databaze
      s:=AnsiToUpAscii(sNick)+VerToSuffix(StrToInt(sVer));
      CwgDB.ParamsClear();
      CwgDB.AddParamText(':nameUp',s);
      CwgDB.AddParamText(':name',AnsiToUtf(sNick));  //Name a Comment prevadime na UTF-8!!!
      CwgDB.AddParamInt(':id',iId);
      CwgDB.AddParamText(':cat',AnsiToUtf(sCat));
      CwgDB.AddParamInt(':ver',StrToInt(sVer));
      CwgDB.AddParamText(':dat',sDat);
      CwgDB.AddParamInt(':isdat',iIsCacheFound);
      CwgDB.AddParamInt(':cnt',1);
      CwgDB.AddParamText(':cacheId',AnsiToUtf(sCacheId)); //teoreticky tam muze byt jakykoli text
      CwgDB.AddParamText(':img',sUrl);
      CwgDB.AddParamText(':guid',sOdkaz);
      CwgDB.AddParamText(':comName',AnsiToUtf(sNickText));
      CwgDB.AddParamText(':comId',AnsiToUtf(sIdText));
      CwgDB.AddParamText(':comDate',AnsiToUtf(sDatText));
      CwgDB.AddParamText(':comImg',AnsiToUtf(sImgText));
      CwgDB.AddParamText(':group',AnsiToUtf(sTabGroup));
      {
      if(sNick='003') then ShowMessage('KKKKK INSERT:'+CRLF
        +'nameUp='+s+CRLF
        +'name='+sNick+CRLF
        +'ID='+IntToStr(iId)+CRLF
        +'cat='+sCat+CRLF
        +'ver='+sVer+CRLF
        +'dat='+sDat+CRLF
        +'isdat='+IntToStr(iIsCacheFound)+CRLF
        //+'cnt='+IntToStr(cnt)+CRLF
        +'sCacheId='+sCacheId+CRLF
        +'img='+sUrl+CRLF
        +'guid='+sOdkaz+CRLF
        +'comName='+sNickText+CRLF
        +'comId='+sIdText+CRLF
        +'comDate='+sDatText+CRLF
        +'comImg='+sImgText+CRLF
        +'group='+sTabGroup+CRLF
      );
      }
      s:='INSERT INTO '+TABLE_FOUND
        +' (NameUpAscii, Name, Id, Category, Version, DateFound, IsCacheFound, Cnt, CacheId,  Img,  GUID,  CommentName, CommentCacheId, CommentDate, CommentImg, TabGroup) '
        +' VALUES (:nameUp, :name, :id, :cat, :ver,   :dat,      :isdat,       :cnt, :cacheId, :img, :guid, :comName,    :comId,         :comDate,    :comImg,    :group)';
      CwgDB.ExecSQL(s);
    finally
      if(tab<>nil) then tab.Free();
    end;
  end;
end;

procedure GetOldCwgList;
var tab: TSqliteTable;
    counter,max,i{,n}: integer;
    s,s1,dotaz,sCat:string;
    sNick,sCacheId,sVer,sTyp,sDat,sOdkaz,sIdText,sNickText,sImgText,sDatText,sUrl:string;
    iIsCacheFound:integer;
    a:TStringList;
begin
  //napred obsah alternativniho souboru
  a:=TStringList.Create();
  a.sorted:=true;
  a.duplicates:=dupAccept; //akceptovat duplnicitni CWG
  s:=OldAltPathname();
  if(FileExists(s)) then a.LoadFromFile(s);
  //ShowMessage('llllll v souboru je: '+IntToStr(a.Count)+' CWG');
  for i:=0 to a.Count-1 do begin //oriznout jmena a vypustit prazdne radky
    s:=Trim(a[i]);
    if(s<>'') then begin
      ParseOldInfo(s,sNick,sCacheId,sVer,sTyp,sDat,sOdkaz,sIdText,sNickText,sImgText,sDatText,sUrl);
      if(sDat='') then iIsCacheFound:=2 //nalezeno, ale datum nezname
      else iIsCacheFound:=1;                //nalezeno, tatum je zadano a lisi se od data nalezu kese
      AddFoundCwg(sNick,sCacheId,sVer,'CWG',sTyp,sDat,sOdkaz,sUrl,sIdText,sNickText,sImgText,sDatText,'',iIsCacheFound);
    end;
  end;
  a.Free();
  //ted se popereme se zaznamy v databazi GeoGetu
  dotaz:=' FROM geocache gc, geotag gt, geotagcategory gtc, geotagvalue gtv '
     +'  WHERE gtc.value="'+TAG_CWG+'" and gtv.key=gt.ptrvalue and '
     +'  gt.id=gc.id and gtc.key=gt.ptrkat ORDER BY gtv.value';
  Counter:=0;
  GeoBusyStart;
  GeoBusyCaption('Generovani seznamu CWG');
  GeoBusyKind('Nacteni seznamu ...');
  //zjistime pocet pro BusyDialog
  max:=Geoget_DB.GetTableValue('SELECT count(gtv.value) '+dotaz);
  Counter:=0;
  //ShowMessage('FFFFF v databazi je '+IntToStr(max)+' CWG');
  tab:=Geoget_DB.GetTable('SELECT gc.id, gtv.value, gc.dtfound '+dotaz,false);
  //i:=0;
  //n:=1;
  try
    while not tab.eof do begin
      if GeoBusyTest then Break;  //preruseno uzivatelem
      Counter:=Counter+1;
  //if(Counter>3) then Break;    //////////////////////////////
      GeoBusyProgress(Counter, max);
      s1:=UtfToAnsi(tab.FieldAsString(0));  // nactem id kese
      s:=UtfToAnsi(tab.FieldAsString(1));  // nactem CWG a info o nem
  //ShowMessage('SSSS 1 Pocet otevreni: iDbOpen='+IntToStr(iDbOpen));
      ParseOldInfo(s,sNick,sCacheId,sVer,sTyp,sDat,sOdkaz,sIdText,sNickText,sImgText,sDatText,sUrl);
      if(sCacheId='') then sCacheId:=s1;
      if(sDat<>'') then iIsCacheFound:=1  //datum nalezu se lisi od data nalezu kese
      else begin
        iIsCacheFound:=0;                     //datum nalezu je identicke s nalezem kese
        sDat:=tab.FieldAsString(2);
      end;
  //ShowMessage('SSSS 2 Pocet otevreni: iDbOpen='+IntToStr(iDbOpen));
      AddFoundCwg(sNick,sCacheId,sVer,sCat,sTyp,sDat,sOdkaz,sUrl,sIdText,sNickText,sImgText,sDatText,'',iIsCacheFound);
      tab.next;                   // skok na dalsi
  //ShowMessage('SSSSS 3 Pocet otevreni: iDbOpen='+IntToStr(iDbOpen));
    end;
  finally
    if(tab<>nil) then tab.free;
  end;
  //ShowMessage('llllll celkem importovano: '+IntToStr(Counter)+' CWG');
end;

procedure ConvertFormat2ToDb(bInit:boolean);
begin
  DBOpen();
  //zkontrolujeme pocet CWG v katalogu a pokud zadne neni, neprevadim, nema to
  //smysl, protoze pak by vsechna prevedena byla "mimo katalog"
  if(CwgDB.GetTableValue('SELECT count(id) FROM '+TABLE_CATALOG)<1) then begin
    if(6<>MessBox('V databzi nen dn CWG z katalogu. Pokud budete'+CRLF+
                 'pokraovat, budou vechna vlastnn CWG "mimo katalog".'+CRLF+CRLF+
                 'Pokraovat v pevodu?'
                 ,'Przd katalog CWG', 4 {tj. Ano/ne, odpoved 6=Ano})) then begin
      DBClose();
      exit;
    end;
  end;
  CwgForm.Visible:=false;
  CwgDB.Start(TABLE_FOUND,''); //zahajime transakci
  SettingsParam(TABLE_SETTINGS_NAME_LASTID,IntToStr(-1));   //vynulujeme pocitadlo CWG mimo katalog
  CwgDB.ExecSQL('DROP TABLE IF EXISTS '+TABLE_FOUND); //vytvorit novou tabulku vlastnenych CWG
  DBCreateTable(TABLE_FOUND);
  GetOldCwgList();               //prepsat puvodni seznamy z DB GG a souboru
  CwgDB.Commit(TABLE_FOUND);   //ukoncime transakci
  DBClose();
  CwgForm.Visible:=true;
  if(bInit=false) then begin
    ShowMessage('INFO: Pevod zskanch CWG/Sigitem ukonen. Po kontrole je mon'+CRLF
             +'z databze GeoGetu odstranit TAG CWG, kter nov verze CWGList'+CRLF
             +'ji nepouv.');
  end;
end;

procedure ConvertDbToDb(bInit:boolean); //konverze formatu DB verze 1 do verze 2
begin
end;
