//nacteni katalogu z HTML stranek Geogadget
{
SQ osobni: catsb%5B%5D=27
SQ eventove: catsb%5B%5D=28
SQ keska: catsb%5B%5D=29
SQ ostatni: catsb%5B%5D=30
MWG osobni: catsb%5B%5D=31
MWG eventove: catsb%5B%5D=32
MWG keska: catsb%5B%5D=33
MWG ostatni: catsb%5B%5D=34
Staty maji catsc%5B%5D=10 az 82 (15.4.2017)

URL=http://www.geokatalog.cz/list.php?cat_chosen=1&<seznam_kategorii>&<seznam_statu>

Po nacteni prvni stranky parsovat pocet stranek a nacist je.
Parsovanim stranek ziskam interni ID a odkaz na obrazeke. Pres interni ID nactu
podrobnosti o kazdem CWG zvlast.

}

const Ggdgt_URL='http://www.geokatalog.cz/list.php';
      Ggdgt_CatSqMin=27;
      Ggdgt_CatSqMax=30;
      Ggdgt_CatMwgMin=31;
      Ggdgt_CatMwgMax=34;
      Ggdgt_ZemeMin=10;
      Ggdgt_ZemeMax=82;
var Ggdgt_nCwg:integer;

procedure GgdgtAddCwg(sName,sId,sCat,sZeme,sImg,sGuid,sZarazeno,sCatalog:string;iVer:integer);
var i:Integer;
    s:string;
begin
  try
    if(CwgDB=nil) then begin ShowMessage('ERR: DB neni otevrena.'); GeoAbort(); end;
    //zkontrolujeme, zda guid neobsahuje cele url, pokud ano, vyhodime jej
    //(v tom pripade obsahuje i mezery kolem pomlcek v guid, ty vyhodime take)
    i:=Pos('?guid=',sGuid);
    if(i>0) then sGuid:=Copy(sGuid,i+6,Length(sGuid));
    CwgDB.AddParamInt(':id',StrToInt(sId));
    CwgDB.AddParamInt(':ver',iVer);
    CwgDB.AddParamText(':cat',sCat);
    i:=CwgDB.GetTableValue('SELECT count(ID) FROM '+TABLE_CATALOG+' where ID=:id and VERSION=:ver and CATEGORY=:cat');
    if(i=0) then begin //pridame CWG
      if(Pos('cwg',sCat)=1) then sCat:='mwp'; //kvuli Bob and Bobek, ktery ma chybne kategorii v katalogovem cisle
      if(Pos('sq',sCat)=1) then CwgDB.AddParamText(':catalog','G-SQ')
      else if(Pos('mw',sCat)=1) then CwgDB.AddParamText(':catalog','G-MWG')
      else begin
        ShowMessage('Nactena neocekavana kategorie '''+sCat+''' (ocekava se sq* nebo mw*)');
        CwgDB.AddParamText(':catalog','G-???');
      end;
      CwgDB.AddParamText(':nameUp',AnsiToUpAscii(sName)+VerToSuffix(iVer));
      CwgDB.AddParamText(':name',AnsiToUtf(sName));
      CwgDB.AddParamInt(':id',StrToInt(sId));
      CwgDB.AddParamText(':cat',sCat);
      CwgDB.AddParamText(':country',sZeme);
      CwgDB.AddParamInt(':ver',iVer);
      CwgDB.AddParamText(':jpg',sImg);
      CwgDB.AddParamText(':guid',sGuid);
      CwgDB.AddParamText(':cache','');
      CwgDB.AddParamText(':comment','');
      CwgDB.AddParamText(':zar',sZarazeno);
      s:='INSERT INTO '+TABLE_CATALOG
        +' (NameUpAscii, Name, Id, Category, Version, Country, Jpg, UserGuid, CacheID, Comment, Catalog, Zarazeno) '
        +' VALUES (:nameUp, :name, :id, :cat, :ver, :country, :jpg, :guid, :cache, :comment, :catalog, :zar)';
      CwgDB.ExecSQL(s);
    end;
  finally
  end;
end;

//zkonstruovat URL
function GgdgtMakeUrl(cat:string; page:integer):string;
var i,iMin,iMax:integer;
begin
  Result:='';
  //pokud je vyssi stranka, do URL se dava jen jeji cislo, protoze server si
  //pamatuje predchozi nastaveni
  if(page>0) then Result:=Ggdgt_URL+'?page='+IntToStr(page)
  else begin
    Result:=Ggdgt_URL+'?cat_chosen=1';
    case cat of
    'SQ':  begin iMin:=Ggdgt_CatSqMin; iMax:=Ggdgt_CatSqMax; end;
    'MWG': begin iMin:=Ggdgt_CatMwgMin; iMax:=Ggdgt_CatMwgMax; end;
    else   begin
             ShowMessage('Neznama kategorie ('+cat+') pro cteni katalogu.');
             exit;
           end;
    end;
    //seznam kategorii a statu ke stazeni
    for i:=iMin to iMax do Result:=Result+'&catsb%5B%5D='+IntToStr(i);
    for i:=Ggdgt_ZemeMin to Ggdgt_ZemeMin do Result:=Result+'&catsc%5B%5D'+IntToStr(i);
    //seznam statu
    //for i:=iMin to iMax do Result:=Result+'&catsb%5B%5D='+IntToStr(i);
    //for i:=Ggdgt_ZemeMin to Ggdgt_ZemeMax do Result:=Result+'&catsb%5B%5D='+IntToStr(i);
  end;
end;

//zjisti pocet stranek s SQ nebo MWG
function GgdgtGetCountPages(sHtml:string):integer;
var s:string;
begin
  Result:=0;
  Fetch(sHtml,'</select></form> Str');
  Fetch(sHtml,' z ');
  s:=Fetch(sHtml,' ');
  Result:=StrToInt(s);
end;

function GgdgtParseCatId(str:string; var sCategory,sId:string; var iNum:integer):boolean;
var s:string;
begin
  s:=RegexSubstitute('([a-zA-z]+)([0-9]+)-([0-9]+)',str,'$1|$2|$3');
  sCategory:=Fetch(s,'|');
  sId:=Fetch(s,'|');
  iNum:=StrToInt(s);
  Result:=((sCategory<>'') and (sId<>''));
end;


procedure GgdgtParseItems(sHtml,sCatalog:string);
var sId,sIdVer,sName,sImg,sIdCat,sDate,sGuid,sCat,sZeme,sVer,sCwg:string;
    b,bStart:boolean;
    iVer:integer;
begin
  bStart:=true;
  while(sHtml<>'') do begin
    //Fetch(sHtml,'<div class="coin"'); //zacatek divu s coinem
    sCwg:=Fetch(sHtml,'<div class="status"'); //zacatek dalsiho divu, nacte div s jednim CWG
    //pokud zaciname zpracovani souboru, musime prvni CWG nacist
    if(bStart) then sCwg:=Fetch(sHtml,'<div class="status"');
    bStart:=false;
    Fetch(sCwg,'</div>');            //konec divu se stavem
    Fetch(sCwg,'<a title="');       //zacatek jmena
    //{$ifdef DEBUG_HELPER} LDH('   sCwg='+ReplaceString(Copy(sCwg,1,100),CRLF,' ')); {$endif}
    sName:=Fetch(sCwg,'"');          //jmeno v UTF
    //{$ifdef DEBUG_HELPER} LDH('   sName='+sName); {$endif}
    Fetch(sCwg,'href="coin.php?id='); //zacatek interniho ID
    sIdCat:=Fetch(sCwg,'"');         //interni ID, pres ktere ziskame podrobnosti
    //{$ifdef DEBUG_HELPER} LDH('   sIdCat='+sIdCat); {$endif}
    Fetch(sCwg,'<img src="');        //zacatek obrazku
    sImg:=Fetch(sCwg,'"');           //obrazek (kategorie, Id, verze)
    //{$ifdef DEBUG_HELPER} LDH('   sImg='+sImg); {$endif}
    //nacteme informaci o konkretnim ID
    //{$ifdef DEBUG_HELPER} LDH('   Podrobnosti '+sIdcat); {$endif}
    b:=HttpAsk('GET','http://www.geokatalog.cz/coin.php?id='+sIdCat,'','',sCwg);
    //StringToFile(sCwg,GetOfflineDir()+'GeoGadget_Detail.html');
    //StringToFile(sCwg,GetOfflineDir()+'GeoGadget_Detail'+IntToStr(Ggdgt_nCwg)+'.html');
    //parsujeme informace o CWG
      Fetch(sCwg,'<h2 class="h2coin">');  //zacatek
    sCwg:=UtfToAnsi(sCwg);
    //cislo verze a kategorii nejde brat z obrazku, protoze tam maji
    //nahodnou velikost pismen a za pomlckou (jak v obrazku tak v katalogovem
    //cisle) je nejake podivne cislo, ktere se ne vzdy s verzi shoduje
    //nebereme to z katalogoveho cisla, ale z verze
    Fetch(sCwg,'Katalogov slo: </span>');
    //{$ifdef DEBUG_HELPER} LDH(' Katalogove cislo  sCwg: '+ReplaceString(Copy(sCwg,1,100),CRLF,'')); {$endif}
    sIdCat:=Fetch(sCwg,'</div>');
    //{$ifdef DEBUG_HELPER} LDH(' sIdCat='+sIdCat); {$endif}
    Fetch(sCwg,'Verze: </span>');
    //{$ifdef DEBUG_HELPER} LDH(' Verze  sCwg: '+ReplaceString(Copy(sCwg,1,100),CRLF,'')); {$endif}
    sVer:=Fetch(sCwg,'</div>');
    //{$ifdef DEBUG_HELPER} LDH(' sVer='+sVer); {$endif}
    //Fetch(sCwg,'Ronk: </span>');
    //sRocnik:=Fetch(sCwg,'</div>');
    Fetch(sCwg,'Pidno: </span>');
    //{$ifdef DEBUG_HELPER} LDH(' Pridano  sCwg: '+ReplaceString(Copy(sCwg,1,100),CRLF,'')); {$endif}
    sDate:=ReplaceString(Fetch(sCwg,'</div>'),'-','');
    //Odkaz nemusi byt
    if(Pos('Odkaz: </span>',sCwg)>1) then begin
      Fetch(sCwg,'Odkaz: </span>');
      //{$ifdef DEBUG_HELPER} LDH(' Odkaz  sCwg: '+ReplaceString(Copy(sCwg,1,100),CRLF,'')); {$endif}
      Fetch(sCwg,'href="');
      sGuid:=Fetch(sCwg,'"');
    end else sGuid:='';
    Fetch(sCwg,'Tag: </span>');
    //{$ifdef DEBUG_HELPER} LDH(' Tag  sCwg: '+ReplaceString(Copy(sCwg,1,100),CRLF,'')); {$endif}
    sZeme:=RegexSubstitute('\?catsb\[\]=.*>([A-Z]{2})</a',sCwg,'$1');
    if(sImg[1]='.') then sImg:='http://www.geokatalog.cz'+Copy(sImg,2,1000)
    else if(sImg[1]='/') then sImg:='http://www.geokatalog.cz'+sImg;
    b:=GgdgtParseCatId(sIdCat,sCat,sId,iVer);
          sIdVer:=RegexSubstitute('[0-9]*[-]([0-9]+)',sIdCat,'$1');
          if(sIdVer='') then sIdVer:='1';
{$ifdef DEBUG_HELPER}
          if(sIdVer<>sVer) then begin
            LDHE('WARN: nesoulad mezi verzi a cislem za pomckou v ID: ('
              +'sIdCat='+sIdCat+', sVer='+sVer+', sIdVer='+sIdVer+')');
          end;
{$endif}
    iVer:=StrToInt(sVer); //prepiseme cislo verze z sIdCat skutecnou verzi
    if(b) then begin
      Inc(Ggdgt_nCwg);
//{$ifdef DEBUG_HELPER} LDH('   n='+IntToStr(Ggdgt_nCwg)+': sIdCat='+sIdCat
//  +', sCat='+sCat+', sId='+sId+', iVer='+IntToStr(iVer)+', sZeme='+sZeme
//  +', sDate='+sDate
//  +', sName='+UtfToAnsi(sName)
//  +', sImg='+sImg+', sGuid='+sGuid); {$endif}
      GgdgtAddCwg(sName,sId,sCat,sZeme,sImg,sGuid,sDate,sCatalog,iVer);
      GeoBusyKind('Importovano: '+IntToStr(Ggdgt_nCwg));
    end;
  end;
end;

//import jedne kategorie SQ nebo MWG z HTML verze katalogu
procedure GgdgtImportCategory(cat:string);
var sUrl,sHtml,sCatalog:string;
    i,nPages:integer;
    b:boolean;
begin
{$ifdef DEBUG_HELPER} LDH('Nacitam kategorii '+cat+' z HTML stranek GeoGadget'); {$endif}
  GeoBusyStart();
  GeoBusyCaption('Import '+cat+' z HTML stranek GeoGadget');
  Ggdgt_nCwg:=0;
  try
    DBOpen();
    CwgDB.Start('GeoGadget',''); //zahajime transakci
    CwgForm.Hide();
    sCatalog:='G-'+cat;
    CwgDB.ExecSQL('DELETE FROM '+TABLE_CATALOG+' WHERE Catalog="'+sCatalog+'"');

    sUrl:=GgdgtMakeUrl(cat,0);
    b:=HttpAsk('GET',sUrl, '', '', sHtml);
    if(not b) then begin
      ShowMessage('ERR: chyba cteni HTML katalogu');
      exit;
    end;
    nPages:=GgdgtGetCountPages(sHtml);
  {$ifdef DEBUG_HELPER} LDH('   Pocet stranek katalogu: '+IntToStr(nPages)); {$endif}
    //nPages:=2;
    //nacteme vsechny stranky
    for i:=0 to nPages-1 do begin
      //if(i<>0) and (i<>29) then continue;
      GeoBusyProgress(i,nPages);
      sUrl:=GgdgtMakeUrl(cat,i);
      if(GeoBusyTest()) then begin
        break;
      end;
  {$ifdef DEBUG_HELPER} LDH('   sUrl='+sUrl); {$endif}
      b:=HttpAsk('GET',sUrl, '', '', sHtml);
      if(not b) then begin
        ShowMessage('ERR: chyba cteni HTML katalogu');
        exit;
      end;
      //StringToFile(sHtml,GetOfflineDir()+'GeoGadget'+cat+'_'+IntToStr(i)+'.html');
      GgdgtParseItems(UtfToAnsi(sHtml),sCatalog);
    end;
    GeoBusyProgress(nPages,nPages);
  finally ;
    CwgDB.Commit('GeoGadget');   //ukoncime transakci
    CwgForm.Show();
    DBClose();
  end;
  ShowMessage('Pocet importovanych '+cat+': '+IntToStr(Ggdgt_nCwg));
end;